export declare type Unwait<T> = T extends (...args: infer A) => infer R ? Promise<T> & ((...args: A) => Unwait<R>) : T extends Promise<infer R> ? Promise<R> & {
    readonly [K in Exclude<keyof R, keyof Promise<R>>]: Unwait<R[K]>;
} : Promise<T> & {
    readonly [K in Exclude<keyof T, keyof Promise<T>>]: Unwait<T[K]>;
};
/**
 * Creates a proxy that defers all property and function access until it's target result has resolved.
 *
 * The target, and any of it's properties and method results can be called immediately,
 * and will return a proxied promise of the result when all promises in the chain resolve.
 * @param target The target to proxy.
 */
export declare function unwait<T>(target: T): Unwait<T>;
export default unwait;
